<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2007 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

  /* 
     This file contains configuration defaults.  Do NOT modify this 
     file; It will be automatically overwritten on future upgrades.
     Instead, please add configuration entries to 

 		src/include/config_site.php 
  */

  /* Do not remove this line */
include_once "vars.php";

// The PO site url
$site_url = "http://localhost/po";
// This appears in the titlebar on every page.
$site_title = "My Photo Organizer";

$ad_script = FALSE;

// A URL to the bug tracker or whatnot for this site
$bug_url = "http://bugs.shaftnet.org/";

/* Database connection details */

// Use a local database via UNIX socket (fast and secure, default)
$db_dsn = "dbname=po_db user=po_user password=po_password";

// Use a local database via IP (slower)
// $db_dsn = "host=127.0.0.1 port=5432 dbname=po_db user=po_user password=po_password";

// Use an external database via IP 
// $db_dsn = "host=128.61.15.251 port=5432 dbname=po_db user=po_user password=po_password";

/* End Database details */

// content based image retrieval server connection details:
$cbir_host = "";
$cbir_port = "";

// Use output compression?
$compress_pages = true;

// Allow bulk uploads from local filesystem?
$local_bulk_upload = false;

// absolute path to your image repository which
// is used to store all your image files
$image_repository_path = "/export/po_dev_image_repository";

// absolute path to where photo organizer should store sessions
// leave blank to use system default.
$po_session_lifetime = 60*60*24*30; /* One month */
$po_session_path = "";

// absolute path to your temporary directory which
// is used to store printed files while they are converted
// and to perform bulk uploads
$tmp_volume_path = "/tmp";

// ImageMagick convert tool
$sys_convert = "/usr/bin/convert";
// ImageMagick composite tool
$sys_composite = "/usr/bin/composite";

/* Alternatively, if you want to use GraphicsMagick: */
// $sys_convert = "/usr/bin/gm convert";
// $sys_composite = "/usr/bin/gm composite";

// Dave Coffin's raw image decoder
$sys_dcraw = "/usr/local/bin/dcraw";

// exiftool utility
$sys_exiftool = "/usr/bin/exiftool";

// UFRaw batch decoder
$sys_ufraw = "/usr/local/bin/ufraw-batch";

/* Raw decoders, in order of prescedence */
$raw_decoder = "dcraw,ufraw,exiftool"; 

// dcm2pnm tool from the dcmtk suite
$sys_dcm2pnm = "/usr/local/dicom/bin/dcm2pnm";

// PS2PDF - converts PS documents into PDF ones
$sys_ps2pdf  = "/usr/bin/ps2pdf";

// gtar - must support the -z and -j options
$sys_tar = "/bin/tar";

// unzip
$sys_unzip = "/usr/bin/unzip";

// The path to the current theme - relative to the PO installation directory
$theme = "themes/aqua";

/* Default options */
$po_options = array(
		    "lang" => "en_US",  /* See lang/ for your options */

		    "order_by" => 7,
		    "photos_per_page" => 20,
		    "rows_list_view" => 20,
		    "photo_view" => "slide", // or 'list'
		    
		    "preview_format" => 'jpeg',  # or 'png'
		    "preview_quality" => 85,
		    "preview_color_space" => "RGB",
		    "preview_gamma" => 1,
		    "preview_sharpen_radius" => 0.5,
		    "preview_sharpen_sigma" => 0.5,
		    "preview_sharpen_amount" => 1.4,
		    "preview_sharpen_threshold" => 0.05,
		    "preview_border_width" => 0,
		    "preview_border_height" => 0,
		    "preview_border_color" => "000000",

		    "thumb_format" => 'jpeg',  # or 'png'
		    "thumb_quality" => 85,
		    "thumb_color_space" => "RGB",
		    "thumb_gamma" => 1,
		    "thumb_sharpen_radius" => 0.5,
		    "thumb_sharpen_sigma" => 0.5,
		    "thumb_sharpen_amount" => 2.2,
		    "thumb_sharpen_threshold" => 0.00,
		    "thumb_border_width" => 0,
		    "thumb_border_height" => 0,
		    "thumb_border_color" => "000000",

		    "watermark_brightness" => 0,
		    "watermark_location" => "center",

		    "preview_copy_metadata" => 't',
		    "colorspace" => 1, //from vars.php

		    "ufraw_gamma" => 0.45,
		    "ufraw_gamma_linearity" => 0.10,
		    "dcraw_brightness" => 1.0,
		    "raw_white_balance" => "camera",
		    "raw_bitdepth" => 24,
		    "jpgfromraw" => 't',

		    "print_out" => "pdf",  // "ps" or "pdf"
		    "start_hour" => 8,
		    "end_hour" => 20,
		    "start_day" => 1, 
		    "paper" => 13,
		    "label" => 17,
		    "popup_enable" => 't',
		    "popup_delay" => 100,
		    "search_enable_stemming" => 'f',
		    "search_engine_type" => 1

		    );

/* We need this to track changes */
$po_options_default = array();

$po_options_default['new_user_type'] = PO_USER_TYPE_USER; 
$po_options_default['volume_max_size'] = 640; // MB
$po_options_default['bulk_upload_enable'] = 't'; 
$po_options_default['quota_size'] = 0;   // in bytes
$po_options_default['quota_count'] = 0;  // in files

// You might want to add more forbidden keywords
$forbidden_keywords = array("a", "b", "c", "d", "e", "f", "g", "h",
                             "i", "j", "k", "l", "m", "n",  "o", "p",
                             "q", "r", "s", "t", "u", "v", "w", "x", "y", "z",
                             "on", "in", "the", "of", "to", "at", "an", "as");

/* Default error reporting level */
error_reporting(E_ALL ^ E_NOTICE);

/* Default credentials expiration time */
$default_cred_timeout = 60 * 10;  // 10 minutes

$po_version = "2.34";

/* Do NOT modify anything below this line unless you know what you're doing */
$install_enabled=0;
include_once "config_site.php";

$po_options['last_updated'] = '';
$po_options['watermark_photo'] = 0;
$po_options['watermark_path'] = '';
$po_options['passwords'] = array();

foreach ($po_options as $key => $value) {
  $po_options_default[$key] = $value;
}

$po_options['bulk_upload_enable'] = $po_options_default['bulk_upload_enable'];
$po_options['quota_size'] = $po_options_default['quota_size'];
$po_options['quota_count'] = $po_options_default['quota_count'];

include_once "lang/en_US.php";
include_once "$theme/theme.php";

?>
