<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2007 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/config.php";
include_once "include/profile.php";
include_once "include/site.php";
include_once "include/common.php";

$type = 'lens';
$database = site_prolog(PO_USER_TYPE_USER);

$manufacturer_filter = pg_escape_string(isset($_REQUEST['filter']) ? $_REQUEST['filter'] : "");

$manufacturer = pg_query($database, "select identifier, name from manufacturer order by name");

switch ($manufacturer_filter) {
 case 'All':
 case '':
   $lens_type = pg_query($database, "select identifier, name, model, variation, s_min_aperture,
                                             s_max_aperture, s_min_focal_length, s_max_focal_length, url
                                        from view_lens_type order by name");
   break;
 default:
   $lens_type = pg_query($database, "select identifier, name, model, variation, s_min_aperture,
                                             s_max_aperture, s_min_focal_length, s_max_focal_length, url
                                        from view_lens_type where view_lens_type.name='$manufacturer_filter' order by name");
}

$focal_length = pg_query($database, "select identifier, value from focal_length order by value");
$aperture     = pg_query($database, "select identifier, value from aperture");

site_header(sprintf($strings['profile']['add'], $strings['generic'][$type]));
site_navigator(6);
site_navigator_status(emit_a("user.php", $strings['generic']['users'])." : ".emit_a("my.profile.php", $strings['generic']['my_profile'])." : ".sprintf($strings['profile']['add'], $strings['generic'][$type]), "");

display_navigator_box_top($profile_data['lens']['idx'], $profile_data, "100%");

if (pg_num_rows($manufacturer) == 0) {
  print emit_manuf_add_needed($type);
  display_navigator_box_bottom("100%");
  site_footer($database);
  site_epilog($database);
  exit;
}

print "<form method=\"post\" action=\"lens.add.2.php\">\n";
print "<table class=\"profile\">\n";

emit_profile_manuf_combo("lens.add.php?type=$type", $type, 4, $manufacturer, $manufacturer_filter);

print "<tr>\n";
print "<th width=\"4%\"></th>\n";
print emit_th($strings['profile']['manufacturer'], "width=\"20%\"");
print emit_th($strings['profile']['model'], "width=\"20%\"");
print emit_th($strings['profile']['variation'], "width=\"20%\"");
print emit_th($strings['profile']['aperture_focal'], "width=\"36%\"");
print "</tr>\n";

$num = pg_num_rows($lens_type);
if ($num > 0) {
  for ($i=0; $i < $num; $i++) {
    $r = pg_fetch_row($lens_type, $i);
    print "<tr>\n";
    print "<td><input type=\"radio\" name=\"lens_type_id\" value=\"$r[0]\"/></td>\n";
    print "<td><a href=\"$r[8]\">$r[1]</a></td>\n";
    print "<td>$r[2]</td>\n";
    print "<td>$r[3]</td>\n";
    print "<td>";
    print emit_lens_string($r[4], $r[5], $r[6], $r[7]);
    print "</td>\n";
    print "</tr>\n";
  }
 } else {
  print "<tr><td colspan=\"6\">".sprintf($strings['profile']['none_found'], $strings['generic'][$type])." ".$strings['generic']['types'] ."</td></tr>\n";
 }
print "</table>\n";

print "<table class=\"profile\">\n";
print "<tr class=\"folder_top\">\n";
print "<tr class=\"folder_top\"><td colspan=\"6\">".sprintf($strings['profile']['specific_data'], $strings['generic'][$type])."</td></tr>\n";
print "</tr>\n";
print "<tr>\n";
print "<th width=\"4%\"></th>\n";
print emit_th($strings['profile']['manufacturer'], "width=\"20%\"");
print emit_th($strings['profile']['model'], "width=\"20%\"");
print emit_th($strings['profile']['variation'], "width=\"20%\"");
print emit_th($strings['generic']['aperture'], "width=\"18%\"");
print emit_th($strings['generic']['focal_length'], "width=\"18%\"");
print "</tr>\n";

print "<tr>\n";
print "<td>";
print "<input type=\"radio\" name=\"lens_type_id\" value=\"custom\" checked=\"checked\" />";
print "</td>\n";
print "<td>\n";
print emit_manufacturer_combo('manufacturer_id', $manufacturer, "");
print "</td>\n";
print "<td>\n";
print "<input type=\"text\" name=\"lens_model\" />\n";
print "</td>\n";
print "<td>\n";
print "<input type=\"text\" name=\"lens_variation\" />\n";
print "</td>\n";
print "<td>\n";
print "<select name=\"lens_min_aperture_id\">\n";
$num = pg_num_rows($aperture);
for ($i=0; $i < $num; $i++) {
  $r = pg_fetch_row($aperture, $i);
  print emit_option($r[0], $r[1], FALSE);
}
print "</select>-";
print "<select name=\"lens_max_aperture_id\">\n";
for ($i=0; $i < $num; $i++) {
  $r = pg_fetch_row($aperture, $i);
  print emit_option($r[0], $r[1], FALSE);
}
print "</select>\n";
print "</td>\n";
print "<td>\n";
print "<select name=\"lens_min_focal_length_id\">\n";
$num = pg_num_rows($focal_length);
for ($i=0; $i < $num; $i++) {
  $r = pg_fetch_row($focal_length, $i);
  print emit_option($r[0], $r[1], FALSE);
}
print "</select>-";
print "<select name=\"lens_max_focal_length_id\">\n";
for ($i=0; $i < $num; $i++) {
  $r = pg_fetch_row($focal_length, $i);
  print emit_option($r[0], $r[1], FALSE);
}
print "</select>";
print "</td>\n";
print "</tr>\n";
print "</table>\n";

print "<table class=\"profile\">\n";
print "<tr class=\"folder_top\"><td colspan=\"4\">".sprintf($strings['profile']['specific_data'], $strings['generic'][$type])."</td></tr>\n";

print "<tr>\n";
print emit_th($strings['profile']['serial']);
print emit_th($strings['profile']['purchased']);
print emit_th($strings['profile']['new']);
print emit_th($strings['generic']['access']);
print "</tr>\n";

print "<tr>\n";
print "<td><input type=\"text\" name=\"lens_serial_number\" /></td>\n";
print "<td>\n";
print emit_date_input_form("lens_purchase_timestamp", "");
print "</td>\n";
print "<td>\n"; display_yes_no_combo("lens_purchased_new", "t"); print "</td>\n";
print "<td>\n"; display_access_combo("lens_access_rights", "t", ""); print "</td>\n";
print "</tr>\n";
print "</table>\n";

print $thm_elem['button.add'];
print $thm_elem['button.clear'];
print $thm_elem['button.cancel'];
print "</form>\n";

display_navigator_box_bottom("100%");

site_footer($database);
site_epilog($database);
?>
