<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2007 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


include_once "include/config.php";
;
include_once "include/common.php";
include_once "include/site.php";

$database = site_prolog(PO_USER_TYPE_USER);

$photo_id = pg_escape_string($_REQUEST['photo']);
$photo_data = pg_fetch_row(pg_query($database, "
  select caption, get_image_path(photo_version.identifier, 2) as preview_path, get_image_path(photo_version.identifier, 3) as original_path, users, hide_original, title, access_rights
    from photo, photo_version
   where photo.identifier = photo_version.photo
     and photo_version.master = 't'
     and photo.identifier = '$photo_id'"));

/* Enforce ownership */
if (($po_user['type'] != PO_USER_TYPE_ADMIN) &&
    ($po_user['id'] != $photo_data[3])) {
  site_epilog($database);
  site_push_error($strings['errors']['not_owner']);
  header("Location: login.php");
  exit();
}

$folder_data = pg_fetch_row(pg_query($database, "select folder.identifier, folder.caption from photo, folder where photo.folder = folder.identifier and photo.identifier='$photo_id'"));
$user_data = pg_fetch_row(pg_query($database, "select identifier, last_name, first_name  from users where identifier=$photo_data[3]"));

site_header(sprintf($strings['profile']['add'], $strings['generic']['version']));

$user_display_string = user_disp_string($photo_data[3], $po_user['id'], 
					"", "");

site_navigator(5);

$path_to_folder = get_path_to_folder($database, $folder_data[0]);
$title = get_photo_title($photo_data[5], $photo_data[0]);
site_navigator_status("$user_display_string $path_to_folder : <a href=\"folder.php?folder=$folder_data[0]\">$folder_data[1]</a> : <a href=\"photo.php?photo=$photo_id\">$title</a> : ".sprintf($strings['profile']['add'], $strings['generic']['version']), "");

print "<center>\n";
display_shaded_photo("image.display.php?image=$photo_id&amp;size=2", "", $image_repository_path . "/" . $photo_data[1]);
print "</center>\n";

if (!ini_get("file_uploads")) {
  print err_str($strings['errors']['file_upload_disabled']);
  site_footer($database);
  site_epilog($database);
}

print "<form method=\"post\" action=\"photo.version.add.2.php\" enctype=\"multipart/form-data\">\n";
print "<input type=\"hidden\"name=\"photo\" value=\"$photo_id\" />\n";

print "<table class=\"profile\">\n";
print "<tr>\n";
print emit_th($strings['generic']['master'], "width=\"5%\"");
print emit_th($strings['generic']['remark'], "width=\"45%\"");
print emit_th($strings['generic']['colorspace'], "width=\"15%\"");
print emit_th($strings['import']['image_to_add'], "width=\"35%\"");
print "</tr>\n";
print "<tr>\n";
print "<td>";
display_yes_no_combo("master", "f");
print "</td>";
print "<td>";
print "<input type=\"text\" name=\"comment\" value=\"$photo_version[3]\" />\n";
print "</td>";
print "<td>";
display_colorspace_combo("colorspace", "");
print "</td>";
print "<td>";
print "<input type=\"file\" name=\"file_name[]\" /></td></tr>";

print "</table>\n";
print "<div align=\"center\">\n";
print $thm_elem['button.add'];
print $thm_elem['button.clear'];
print $thm_elem['button.cancel'];
print "</div>";
print "</form>\n";


site_footer($database);
site_epilog($database);
?>
