<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2007 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/config.php";
include_once "include/common.php";
include_once "include/profile.php";
include_once "include/site.php";
;

$owner_id    = pg_escape_string(isset($_REQUEST['user']) ? $_REQUEST['user'] : 0);

$database = site_prolog();

$my_folder = ($po_user['id'] == $owner_id);
$owner_type = $po_user['type'];

if ($owner_id) {
  $tmp = pg_fetch_row(pg_query($database, "select identifier, type from users where identifier=$owner_id"));
  $owner_type = $tmp[1];
}

if ($my_folder) {
  site_header($strings['users']['my_folders']);
  site_navigator(5);
 } else {
  site_header($strings['users']['display']);
  site_navigator(1);
 }

if (($owner_id == 0) || ($owner_type < PO_USER_TYPE_CLIENT)) {
  /* list all users, if no user is specified or the account is disabled */
  site_navigator_status(emit_a("user.php", $strings['generic']['users']) .
			" : ".$strings['users']['select'], "");
  $user_list = pg_query($database, "select identifier, last_name, first_name, member_since, type, hide from users where users.type > ".PO_USER_TYPE_CLIENT." order by last_name, first_name");
  display_users($database, $user_list, $po_user['id']);
} elseif ($owner_type == PO_USER_TYPE_CLIENT) {
  /* display clients */
  $user_name = pg_fetch_row(pg_query($database, "select last_name, first_name from users where users.type = ".PO_USER_TYPE_CLIENT." and identifier=$owner_id"));
  site_navigator_status(emit_a("user.php", $strings['generic']['users'])." : $user_name[0], $user_name[1]", "");

  if ($po_user['type'] > PO_USER_TYPE_DISABLED) {
    $client = pg_fetch_row(pg_query($database, "select identifier from client where users=$po_user[id] and client=$owner_id"));
    if (($client != 0) || ($po_user['type'] == PO_USER_TYPE_ADMIN)) {
      if ($po_user['type'] != PO_USER_TYPE_ADMIN) {
	print "<p>$user_name[1] $user_name[0] ".$strings['users']['registered_customer'] ."</p>";
      }
      display_contact_info($database, $owner_id);
    }
  }
} else {
  /* display users and the administrator */
  $user_name = pg_fetch_row(pg_query($database, "select last_name, first_name from users where users.type > ".PO_USER_TYPE_CLIENT." and identifier=$owner_id"));
  $left = "";
  if ($my_folder) {
    $num_of_photos = pg_fetch_row(pg_query($database, "select count_photos_by_user($po_user[id])"));
    $num_of_folders = pg_fetch_row(pg_query($database, "select count_folders_by_user($po_user[id]) -1 "));
    $num_of_albums = pg_fetch_row(pg_query($database, "select count_albums_by_user($po_user[id]) -1 "));
    $left = sprintf($strings['users']['you_have_photos'], 
		    $num_of_photos[0], 
		    $num_of_folders[0],
		    $num_of_albums[0]);
  }

  site_navigator_status(emit_a("user.php", $strings['generic']['users'])." : $user_name[0], $user_name[1]", $left);
  display_folders($database, "", $owner_id, "with_header");
  display_albums($database, "", $owner_id, $owner_type, "with_header");

  if ($po_user['type'] >= PO_USER_TYPE_CLIENT) {
    print "<div class=\"actions\">";
    print "<form name=\"photoList\" method=\"post\" action=\"folder.content.php\">";
    print "<input type=\"hidden\" name=\"return\" value=\"user.php?user=$owner_id\"/>";
    print "<input type=\"hidden\" name=\"user\" value=\"$owner_id\"/>";
    display_spool_actions($database, $po_user['id']);
    print "</form>";
    print "</div>";
  }

  if (!$my_folder) {
    $equipment_by_user = pg_fetch_row(pg_query($database, "select count_equipment_by_user($owner_id, $access[public])"));
    if ($equipment_by_user[0] > 0) {
      display_lens($database, $po_user['id'], $owner_id);
      display_camera($database, $po_user['id'], $owner_id);
      display_profile($database, "flash", $po_user['id'], $owner_id);
      display_profile($database, "scanner", $po_user['id'], $owner_id);
      display_profile($database, "filter", $po_user['id'], $owner_id);
      display_film($database, $po_user['id'], $owner_id);
      display_profile($database, "support", $po_user['id'], $owner_id);
    }

    if ($po_user['id']) {
      $client = pg_fetch_row(pg_query($database, "select identifier from client where users=$po_user[id] and client=$owner_id"));
      if ($client != FALSE) {
	print "<p>$user_name[1] $user_name[0] ".$strings['users']['registered_customer'] ."</p>";
      } 
      if (($client != 0) || ($po_user['type'] == PO_USER_TYPE_ADMIN)) {
	display_contact_info($database, $owner_id);
      }

      if ($po_user['type'] != PO_USER_TYPE_ADMIN) {
	$already_client = pg_query($database, "select identifier from client where users=$owner_id and client=$po_user[id] and status!=4");
	if (pg_num_rows($already_client) == 0) {
	  print "<p>".$strings['users']['register_prompt']." $user_name[1] $user_name[0].</p>";
	  
	  print "<form method=\"post\" action=\"subscription.add.php\">";
	  print "<input type=\"hidden\" name=\"user\" value=\"$owner_id\"/>\n";
	  print "<center>";
	  print $thm_elem['button.subscribe'];
	  if ($po_user['type'] > PO_USER_TYPE_CLIENT) {
	    print $thm_elem['button.make_client'];
	  }
	  print "</center>";
	  print "</form>";
	}
      }
    }
  }
 }

site_footer($database);
site_epilog($database);
?>
