<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2007 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


include_once "include/config.php";
include_once "include/tools.php";
;
include_once "include/common.php";
include_once "include/site.php";
include_once "include/export.php";

$database = site_prolog(PO_USER_TYPE_USER);

$source_file_tmp       = $_REQUEST['source_file_tmp'];
$source_file_extension = $_REQUEST['source_file_extension'];

$file_name_root     = $_REQUEST['file_name'];
$file_number_digits = $_REQUEST['file_number_digits'];
$file_format        = $_REQUEST['file_format'];
$file_number_start  = $_REQUEST['file_number_start'];
$frame_number       = $_REQUEST['frame_number'];

$date_of_exposure   = check_date_validity($_REQUEST['date_of_exposure']);

$storage_size       = $_REQUEST['storage_size'];

$image_data = array ("folder"                => $_REQUEST['folder'],
                     "author"                => $_REQUEST['author'],
                     "title"                 => $_REQUEST['title'],
                     "keyword"               => $_REQUEST['keyword'],
                     "caption"               => $_REQUEST['caption'],
                     "copyright"             => $_REQUEST['copyright'],
                     "date_of_exposure"      => $date_of_exposure,
                     "location"              => $_REQUEST['location'],
                     "storage_location_type" => $_REQUEST['storage_location_type'],
                     "storage_location_id"   => $_REQUEST['storage_location_id'],
                     "storage_index"         => $_REQUEST['storage_index'],
                     "access_rights"         => $_REQUEST['access_rights'],
                     "hide_original"         => $_REQUEST['hide_original'],
                     "store_url"             => $_REQUEST['store_url'],
                     "camera"                => $_REQUEST['camera'],
                     "lens"                  => $_REQUEST['lens'],
                     "filter"                => $_REQUEST['filter'],
                     "film"                  => $_REQUEST['film'],
                     "flash"                 => $_REQUEST['flash'],
                     "scanner"               => $_REQUEST['scanner'],
                     "focal_length"          => $_REQUEST['focal_length'],
                     "aperture"              => $_REQUEST['aperture'],
                     "shutter"               => $_REQUEST['shutter'],
                     "exp_comp"              => $_REQUEST['exp_comp'],
                     "exp_diff"              => $_REQUEST['exp_diff'],
                     "camera_metering"       => $_REQUEST['camera_metering'],
                     "camera_program"        => $_REQUEST['camera_program'],
                     "flash_mode"            => $_REQUEST['flash_mode'],
                     "flash_comp"            => $_REQUEST['flash_comp'],
                     "scan_resolution"       => $_REQUEST['scan_resolution'],
                     "scan_bitdepth"         => $_REQUEST['scan_bitdepth'],
                     "scan_multiscan"        => $_REQUEST['scan_multiscan'],
                     "iso_override"          => $_REQUEST['iso_override'],
                     "support"               => $_REQUEST['support']);

$tmp_value = pg_fetch_row(pg_query($database, "select value from scan_resolution where identifier=".$image_data['scan_resolution'])); $image_data['scan_resolution'] = $tmp_value[0];
$tmp_value = pg_fetch_row(pg_query($database, "select value from scan_bitdepth   where identifier=".$image_data['scan_bitdepth']));   $image_data['scan_bitdepth']   = $tmp_value[0];
$tmp_value = pg_fetch_row(pg_query($database, "select value from scan_multiscan  where identifier=".$image_data['scan_multiscan']));  $image_data['scan_multiscan']  = $tmp_value[0];

site_header("Tools : XML Converter");
site_navigator(10);
site_navigator_status(emit_a("user.php", $strings['generic']['users'])." : ".emit_a("my.tools.php", $strings['generic']['my_tools'])." : <a href=\"xml.converter.php\">XML Converter</a> : XML File", "");

error_reporting(0);
$fd = fopen($source_file_tmp, "r");
if (!$fd) {
  print "&nbsp;<br/>\n";
  print "<div align=\"center\">Failed to open source file</div>";
  print "&nbsp;<br/>\n";
  site_footer($database);
  site_epilog($database);
  exit();
}

$header_data = convert_read_header($fd, $source_file_extension);
$shooting_data = convert_read_body($fd, $source_file_extension);
fclose($fd);
unlink($source_file_tmp);

print "&nbsp;<br/>";
display_navigator_box_top($tools_data['converter']['idx'], $tools_data, "100%");

print "&nbsp;<br/>";
print "<div align=\"left\" >";
print "<code>";

print convert_xml2html(create_xml_header());
print convert_xml2html(create_xml_bulkupload_header());
print convert_xml2html(create_xml_folder_header($image_data['folder']));

for ($i=0; $i < $shooting_data['frames']; $i++) {
  $data = $shooting_data['data'];

  $image_data['shutter'] = $data[$i]['shutter'];
  $image_data['aperture'] = $data[$i]['aperture'];
  $image_data['focal_length'] = $data[$i]['focal_length'];
  $image_data['minimum_aperture'] = $data[$i]['minimum_aperture'];
  $image_data['camera_metering'] = $data[$i]['camera_metering'];
  $image_data['camera_program'] = $data[$i]['camera_program'];
  $image_data['flash_mode'] = $data[$i]['flash_mode'];
  $image_data['exp_comp'] = $data[$i]['exp_comp'];
  $image_data['exp_diff'] = $data[$i]['ev_diff'];
  $image_data['caption'] = $data[$i]['caption'];

  $lens_name = "lens$i";
  $image_data['lens'] = $_REQUEST[$lens_name];

  $flash_name = "flash$i";
  $image_data['flash'] = $_REQUEST[$flash_name];

  $image_data['file'][0]['name']     = sprintf("%s%s.%s", $file_name_root, str_pad($file_number_start + $i, $file_number_digits, "0", STR_PAD_LEFT), $file_format);

  print "&nbsp;<br/>\n";
  print "<code>\n";
  print convert_xml2html(create_xml_photo($image_data));
  print "</code>\n";
  print "&nbsp;<br/>\n";

  if ($storage_size) {
    if ($image_data['storage_index'] == $storage_size) {
      $image_data['storage_index'] = 0;
      $image_data['storage_location_id']++;
    }
  }
  $image_data['storage_index'] ++;
}

print convert_xml2html(create_xml_folder_footer());
print convert_xml2html(create_xml_bulkupload_footer());

print "</code>";
print "</div>";
print "<p>";
print $thm_elem['button.back'];
print "</p>";
display_navigator_box_bottom("100%");

site_footer($database);
site_epilog($database);
?>
